unit Unit1; {$J+}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Menus, JPEG, ExtDlgs, clipbrd;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    sb: TStatusBar;
    ScrollBox: TScrollBox;
    Image1: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Setup1: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    SavePictureDialog: TSavePictureDialog;
    mnunewimage: TMenuItem;
    SaveJPG1: TMenuItem;
    Exit1: TMenuItem;
    mnuopenimage: TMenuItem;
    mnuaddimag: TMenuItem;
    mnucopytoclip: TMenuItem;
    mnupasteimg: TMenuItem;
    Edit1: TMenuItem;
    CropSavetoFile1: TMenuItem;
    CropSavetoClipboard1: TMenuItem;
    mnuWiteText: TMenuItem;
    mnushrinkmain: TMenuItem;
    Info1: TMenuItem;
    About1: TMenuItem;
    Help1: TMenuItem;
    mnuAddPic: TMenuItem;
    mnusavBMP: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Exit1Click(Sender: TObject);
    procedure mnuopenimageClick(Sender: TObject);
    procedure mnunewimageClick(Sender: TObject);
    procedure mnuaddimagClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure SaveJPG1Click(Sender: TObject);
    procedure mnucopytoclipClick(Sender: TObject);
    procedure mnupasteimgClick(Sender: TObject);
    procedure mnushrinkmainClick(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure mnuWiteTextClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure mnuAddPicClick(Sender: TObject);
    procedure CropSavetoFile1Click(Sender: TObject);
    procedure CropSavetoClipboard1Click(Sender: TObject);
    procedure mnusavBMPClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  mainbitmap,brushbmp,movbitmap,tempbitmap,backbitmap,rezultbmp : Tbitmap;
  xnow,ynow : integer;
  appaction :(none,addpicture,writetext,cropimage2File,cropimage2clip,RotatePic);
  const ready : boolean=false;

implementation

uses Unit2, Unit3;

{$R *.DFM}

var x1,y1,x2,y2,appcode : integer;

procedure TForm1.FormCreate(Sender: TObject);
label T1;
begin DoubleBuffered:=true; movbitmap:=Tbitmap.create; movbitmap.PixelFormat:=pf32bit;
      tempbitmap:=Tbitmap.Create; tempbitmap.PixelFormat:=pf32bit;
      mainbitmap:=Tbitmap.Create; mainbitmap.PixelFormat:=pf32bit;
      rezultbmp:=Tbitmap.Create; rezultbmp.PixelFormat:=pf32bit;
      backbitmap:=Tbitmap.Create; backbitmap.PixelFormat:=pf32bit;
      appaction:=none;

if paramstr(1)<>'' then
 begin openpicturedialog.FileName:=paramstr(1);
       if fileexists(openpicturedialog.FileName)=false then goto T1;
       mnuopenimageClick(nil);
 end else with mainbitmap do
 begin T1:
       width:=image1.width; height:=image1.height; canvas.Brush.Style:=bssolid;
       canvas.Brush.Color:=$F0E0F0; canvas.FillRect(rect(0,0,width,height));
       canvas.Pen.Color:=0; canvas.Pen.Width:=2;
       canvas.Ellipse(10,10,width-10,height-10); canvas.Font.Name:='ARIAL';
       canvas.Font.Size:=18; canvas.TextOut(width div 3,height div 2,'Select an image first');
       image1.picture.Bitmap.Assign(mainbitmap); ready:=true
 end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin  mainbitmap.Free;  tempbitmap.Free;
       brushbmp.Free; movbitmap.Free; backbitmap.Free; rezultbmp.Free
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin form2.Show; form2.Top:=-1
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var i,j,k,w,h,d : integer; R : TRect;
begin if ready=false then exit;
 i:=mainbitmap.Canvas.Pixels[x,y]; xnow:=x; ynow:=y;
 sb.Panels[0].Text:='X='+inttostr(x)+'  Y='+inttostr(y)+'   '+inttohex(i,6);

 case appaction of

  addpicture :
 begin setfocus;
       i:=form3.edtmovshrink.Tag; j:=form3.edttransp.Tag;
       shrinkbitmap(i,movbitmap,tempbitmap);
       w:=tempbitmap.Width; h:=tempbitmap.Height;

       backbitmap.Width:=w; backbitmap.Height:=h;
       rezultbmp.Width:=w; rezultbmp.Height:=h;
       backbitmap.Canvas.CopyRect(rect(0,0,w,h),mainbitmap.canvas,rect(x,y,x+w,y+h));
       BlendBitmap(backbitmap,tempbitmap,rezultbmp,j);

       IMAGE1.Picture.Bitmap.Assign(mainbitmap);
       image1.Canvas.CopyRect(rect(x,y,x+w,y+h),rezultbmp.canvas,rect(0,0,w,h));
       sb.Panels[2].Text:='W='+inttostr(w)+'  H='+inttostr(h)
 end;

 RotatePic:
  begin setfocus;
        i:=form3.edtrotangle.Tag; j:=form3.edtmovshrink.Tag;
        k:=100-form3.edttransp.Tag;
        shrinkbitmap(j,movbitmap,tempbitmap);
        w:=tempbitmap.Width; h:=tempbitmap.Height;
        d:=round(sqrt(w*w + h*h)); //diagonal of this image will be side of a new square image
        backbitmap.Width:=d; backbitmap.Height:=d;
        R.Left:=x-((d-w)div 2); R.Top:=y-((d-h) div 2);
        R.Right:=R.Left+d; R.Bottom:=R.top+d;
        backbitmap.Canvas.CopyRect(rect(0,0,d,d),mainbitmap.canvas,R);
        RotateBitmap(tempbitmap,backbitmap,i,k,true);
        IMAGE1.Picture.Bitmap.Assign(mainbitmap);
        image1.Canvas.CopyRect(R,backbitmap.canvas,rect(0,0,d,d))
  end;

 writetext :
     begin setfocus;
           j:=form3.edttransp.Tag;
           image1.picture.bitmap.Assign(mainbitmap);
           TextOutTransparent(form3.edtmsg.text,x,y,j,image1.picture.bitmap);
     end;

   cropimage2File,cropimage2clip: with image1.Canvas do
   begin IMAGE1.Picture.Bitmap.Assign(mainbitmap);
         if appcode=0 then
         begin x1:=x; y1:=y;
               DrawFocusRect(rect(x,y,x+200,y+200))
         end else if appcode=1 then
         begin x2:=x; y2:=y;
              DrawFocusRect(rect(x1,y1,x2,y2))
         end
   end;

  end;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var w,h,i,j,k,d : integer; jp : Tjpegimage; R : Trect;  label L1;
begin if ready=false then exit;

   case appaction of


    cropimage2File,cropimage2clip:
    begin inc(appcode); if appcode=2 then
       begin

             if (x2<=x1)or(y2<=y1) then
             begin showmessage('You have drwan an invalid crop rectangle');
                   goto L1
             end;
             if appaction=cropimage2File then 
             if SavePictureDialog.Execute=false then
             goto L1;
             
             w:=x2-x1; h:=y2-y1; tempbitmap.Width:=w; tempbitmap.Height:=h;
             tempbitmap.Canvas.CopyRect(rect(0,0,w,h),mainbitmap.canvas,rect(x1,y1,x2,y2));
             if appaction=cropimage2File then
             begin
             jp:=Tjpegimage.Create; jp.PixelFormat:=jf24Bit;
             jp.CompressionQuality:=100; jp.Assign(tempbitmap); jp.Compress;
             jp.SaveToFile(SavePictureDialog.FileName); jp.Free;
             showmessage(SavePictureDialog.filename+' was saved')
             end else
             begin clipboard.Assign(tempbitmap);
                   showmessage('Croped area was copied to clipboard');
             end;
             L1:
             appaction:=none; appcode:=0;
             image1.Picture.Bitmap.Assign(mainbitmap)
       end
    end;

   addpicture :
 begin
       i:=form3.edtmovshrink.Tag; j:=form3.edttransp.Tag;
       shrinkbitmap(i,movbitmap,tempbitmap);
       w:=tempbitmap.Width; h:=tempbitmap.Height;

       backbitmap.Width:=w; backbitmap.Height:=h;
       rezultbmp.Width:=w; rezultbmp.Height:=h;
       backbitmap.Canvas.CopyRect(rect(0,0,w,h),mainbitmap.canvas,rect(x,y,x+w,y+h));
       BlendBitmap(backbitmap,tempbitmap,rezultbmp,j);

       mainbitmap.Canvas.CopyRect(rect(x,y,x+w,y+h),rezultbmp.canvas,rect(0,0,w,h));
       image1.picture.bitmap.Assign(mainbitmap)
 end;

 RotatePic:
  begin
        i:=form3.edtrotangle.Tag; j:=form3.edtmovshrink.Tag; k:=100-form3.edttransp.Tag;
        shrinkbitmap(j,movbitmap,tempbitmap);
        w:=tempbitmap.Width; h:=tempbitmap.Height;
        d:=round(sqrt(w*w + h*h));
        backbitmap.Width:=d; backbitmap.Height:=d;
        R.Left:=x-((d-w)div 2); R.Top:=y-((d-h) div 2);
        R.Right:=R.Left+d; R.Bottom:=R.top+d;
        backbitmap.Canvas.CopyRect(rect(0,0,d,d),mainbitmap.canvas,R);
        RotateBitmap(tempbitmap,backbitmap,i,k,true);
        mainbitmap.Canvas.CopyRect(R,backbitmap.canvas,rect(0,0,d,d));
        image1.picture.Bitmap.Assign(mainbitmap)
  end;


  writetext:
     begin
       j:=form3.edttransp.Tag;
       backbitmap.Assign(mainbitmap);
       TextOutTransparent(form3.edtmsg.text,x,y,j,image1.picture.bitmap);
       mainbitmap.Assign(image1.picture.bitmap)
     end;

    end
end;


procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  var i : integer;
begin
    with form3 do
    begin  if rbshrink.Checked then
       begin i:=strtointdef(edtmovshrink.text,0);
             if i<4 then i:=4 else if i>100 then i:=100;
             edtmovshrink.Tag:=i

       end else if rbtransp.Checked  then
       begin i:=strtointdef(edttransp.text,0);
             if i<4 then i:=4 else if i>100 then i:=100;
             edttransp.Tag:=i
       end else if rbrot.Checked then
       begin i:=strtointdef(edtrotangle.text,0);
             if (i>359)then i:=0;
             edtrotangle.Tag:=i

       end;

      if wheeldelta>0 then inc(i) else if wheeldelta<0 then dec(i);
      if (i<0)and(rbrot.Checked=false) then i:=0;
      if rbrot.Checked=false then
      begin
      if i>100 then i:=100 else if i<2 then i:=2;
      end else
      begin if (i>359) then i:=0
      end;
       if rbshrink.Checked then
       begin edtmovshrink.Text:=inttostr(i);
         edtmovshrink.Tag:=i
       end
       else if rbtransp.Checked then
       begin edttransp.Text:=inttostr(i);
             edttransp.Tag:=i
       end else
       begin edtrotangle.Text:=inttostr(i);
             edtrotangle.Tag:=i
       end;
       Image1MouseMove(nil,[],xnow,ynow)
     end
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin close

end;

procedure TForm1.mnuopenimageClick(Sender: TObject);
var j : Tjpegimage; w,h : integer;   label L1;
begin
 if (sender=nil) then goto L1 ;
 if OpenPictureDialog.Execute=false then exit;
 L1:
 j:=tjpegimage.Create; j.PixelFormat:=jf24Bit;
 j.LoadFromFile(OpenPictureDialog.filename);
 if mainbitmap=nil then
 begin mainbitmap:=tbitmap.Create; mainbitmap.PixelFormat:=pf32bit

 end;
 w:=j.Width; h:=j.Height; ready:=false;
 mainbitmap.Width:=w; mainbitmap.Height:=h;
 mainbitmap.Assign(j); mainbitmap.PixelFormat:=pf32bit;
 image1.Picture.Bitmap.Assign(mainbitmap);
 ScrollBox.VertScrollBar.Range:=h;
 scrollbox.HorzScrollBar.Range:=w;
 sb.Panels[1].Text:='W='+inttostr(w)+' H='+inttostr(h);
 if form2<>nil then
 with form2 do
 begin edtw.Text:=inttostr(w); edth.Text:=inttostr(h);
       edtshrinkmainbmp.Text:='100'; edtshrinkmainbmp.Tag:=100
 end;
 if form3<>nil then
 with form3 do
 begin edttransp.Text:='100'; edttransp.Tag:=100;
       edtmovshrink.Text:='100'; edtmovshrink.Tag:=100;
       rbshrink.Checked:=true
 end;
 j.Free; ready:=true; appaction:=none
end;

procedure TForm1.mnunewimageClick(Sender: TObject);
begin  appaction:=none; if form2.Visible=false then form2.ShowModal
end;

procedure TForm1.mnuaddimagClick(Sender: TObject);
var j : tjpegimage;  const i : boolean =true;
begin
 with OpenPictureDialog do
 begin
      if execute=false then exit;
      if fileexists(filename)=false then exit;
      if i then
      begin i:=false;
      showmessage('Mouse mouse freely and click to set image, can be repeated press ESC when done')
      end;
      j:=tjpegimage.Create; j.LoadFromFile(filename);
      ready:=false; //to avoid trigering onchaange event in form3 Edit boxex
      movbitmap.Assign(j); movbitmap.PixelFormat:=pf32bit;
      j.Free; appaction:=addpicture;
      sb.Panels[1].Text:='W='+inttostr(movbitmap.Width)+' H='+inttostr(movbitmap.Height);
      with form3 do
      begin edttransp.Text:='100'; edttransp.Tag:=100; rbshrink.Checked:=true;
            edtmovshrink.Text:='100'; edtmovshrink.Tag:=100;
            Show; Left:=0; ready:=true
      end
 end
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin if key=#27 then
 begin appaction:=none; form3.rbshrink.Checked:=true;
     image1.Picture.Bitmap.Assign(mainbitmap);
     form3.Close
 end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var p : Tpoint;
begin  getcursorpos(p);
     case key of
         vk_up : dec(p.y);
         vk_down: inc(p.y);
         vk_right: inc(p.x);
         vk_left: dec(p.x);
         else exit
      end;
      setcursorpos(p.x,p.y)
end;

procedure TForm1.SaveJPG1Click(Sender: TObject);
var j : Tjpegimage; t : Tbitmap;
begin if sender<>nil then SavePictureDialog.FilterIndex:=1;
 with SavePictureDialog do
 begin if execute=false then exit;

     if filterindex=1 then
     begin
       j:=Tjpegimage.Create; j.PixelFormat:=jf24Bit; j.CompressionQuality:=100;
       t:=tbitmap.Create; t.PixelFormat:=pf24bit;
       t.Width:=mainbitmap.Width; t.Height:=mainbitmap.Height; t.Assign(mainbitmap);
       j.Assign(t); j.Compress; j.SaveToFile(filename); j.Free
      end else
      begin t:=tbitmap.Create; t.PixelFormat:=pf24bit;
            t.Width:=mainbitmap.Width; t.Height:=mainbitmap.Height;
            t.SaveToFile(SavePictureDialog.filename)
      end; t.Free;
      showmessage('File '+filename+' was saved');
 end
end;

procedure TForm1.mnusavBMPClick(Sender: TObject);
begin SavePictureDialog.FilterIndex:=2;
      SaveJPG1Click(nil)
end;


procedure TForm1.mnucopytoclipClick(Sender: TObject);
begin clipboard.Assign(mainbitmap);
    showmessage('Image copied to clipboard')
end;

procedure TForm1.mnupasteimgClick(Sender: TObject);
var w,h : integer;
begin
 if Clipboard.HasFormat(CF_BITMAP) then
 begin if mainbitmap=nil then
     begin mainbitmap:=tbitmap.Create; mainbitmap.PixelFormat:=pf32bit; ready:=true
     end;
     mainbitmap.Assign(clipboard); appaction:=none;
     image1.Picture.Bitmap.Assign(mainbitmap);
     w:=mainbitmap.Width; h:=mainbitmap.Height;
     ScrollBox.VertScrollBar.Range:=h;
     scrollbox.HorzScrollBar.Range:=w;
     sb.Panels[1].Text:='W='+inttostr(w)+' H='+inttostr(h);
     with form2 do
     begin edtw.Text:=inttostr(w); edth.Text:=inttostr(h)
     end;
 end else
 showmessage('No image exists in clipboard')
end;


procedure TForm1.mnushrinkmainClick(Sender: TObject);
begin 
  if form2.Visible=false then form2.Showmodal
end;

procedure TForm1.mnuWiteTextClick(Sender: TObject);
const i : boolean=true;
begin 
      form3.rbtransp.Checked:=true; form3.Show; form3.left:=0;
      appaction:=writetext;
      if i then
      begin i:=false;
     showmessage('Select the desired font and use mouse wheel to set the transparency '+
     'of the text message use mouse freely and click to write the text, press ESC when done')
      end
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 showmessage('This freeware program with full source code is written by Omid Motahed '+#13+
 'www.facebook.com/motahed  motahed1@yahoo.com')
end;

procedure TForm1.Help1Click(Sender: TObject);
const c=#13#10;
begin
 Showmessage('This is a an image overlaying software very intuitive and easy to use '+
 c+' It is like riding in a smooth rive !'+c+
 'Once background image selected moving the tile pictures is like drag and drop but no need to hold the mouse key down'+c+
 'Use mousewheel for shrinking the moving image or its transparency % at the same time that you move the mouse'+c+
 'If you want you can use arrow keys for more precise motion of mouse pointer')
end;

procedure TForm1.mnuAddPicClick(Sender: TObject);
var w,h : integer;
begin
 if Clipboard.HasFormat(CF_BITMAP) then
 begin 
     movbitmap.Assign(clipboard); appaction:=addpicture;
     w:=movbitmap.Width; h:=movbitmap.Height;
     sb.Panels[1].Text:='W='+inttostr(w)+' H='+inttostr(h);;
      with form3 do
      begin edttransp.Text:='100'; edttransp.Tag:=100; rbshrink.Checked:=true;
            edtmovshrink.Text:='100'; edtmovshrink.Tag:=100;
            Show; Left:=0; ready:=true
      end
     
 end else
 showmessage('No image exists in clipboard')
end;

procedure TForm1.CropSavetoFile1Click(Sender: TObject);
const i : boolean=true;
begin
  if i then
  begin showmessage('2 click to set the crop rectangle that will be saved as JPG file,'+
       ' dont hold mouse key down');
       i:=false
  end;
  appcode:=0; appaction:=cropimage2File
end;

procedure TForm1.CropSavetoClipboard1Click(Sender: TObject);
const i : boolean=true;
begin
  if i then
  begin showmessage('2 click to set the crop rectangle that will be copied to clipboard,'+
       ' dont hold mouse key down');
       i:=false
  end;
  appcode:=0; appaction:=cropimage2Clip
end;


end.
