unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, math,
  StdCtrls, JPEG, ExtCtrls;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    edtW: TEdit;
    EdtH: TEdit;
    btnbackcol: TButton;
    rgbrush: TRadioGroup;
    Shape1: TShape;
    btnmakeBMP: TButton;
    st1: TStaticText;
    Label3: TLabel;
    ColorDialog: TColorDialog;
    btnmodbmp: TButton;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    edtshrinkmainbmp: TEdit;
    btnokshrink: TButton;
    btncancelzoom: TButton;
    procedure btnbackcolClick(Sender: TObject);
    procedure btnmakeBMPClick(Sender: TObject);
    procedure btnmodbmpClick(Sender: TObject);
    procedure edtWKeyPress(Sender: TObject; var Key: Char);
    procedure rgbrushClick(Sender: TObject);
    procedure edtshrinkmainbmpChange(Sender: TObject);
    procedure edtshrinkmainbmpEnter(Sender: TObject);
    procedure btnokshrinkClick(Sender: TObject);
    procedure btncancelzoomClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShrinkBitmap(percent : integer; var main,shrunk : Tbitmap);
procedure BlendBitmap(botbmp,topbmp,rezult : Tbitmap; blend : integer);
procedure TextOutTransparent(s: string; x,y,blend : integer; destbitmap : Tbitmap );

procedure RotateBitmap(source,target : Tbitmap; ang : integer;
     const blend : integer= 100;
     const watermark : boolean= false);

var
  Form2: TForm2;

implementation

uses Unit1, Unit3;

{$R *.DFM}

type
  TPixelRec =
  packed record
    Blue: Byte;
    Green: Byte;
    Red: Byte;
    Reserved: Byte;
  end;


procedure RotateBitmap(source,target : Tbitmap; ang : integer;
     const blend : integer= 100;
     const watermark : boolean= false);
//target is the background image source the image that is rotated
type trw = array[0..maxint div 8] of integer;
var x,y, x2,y2,dx1,dy1,dx2,dy2,ix,iy  : integer;
    Sourceleftlimit,Sourcerightlimit,SourceToplimit,SourceBotlimit : integer;
    sourcescan, destscan : ^trw; //^PPixelRec;
    sinang,cosang : extended;
    pixelsource, pixeltarget, pixeltemp : integer; //TpixelRec;
    AngRad : double;

begin  angrad:=ang*pi/180;
   sincos(angrad,sinang,cosang);
   case ang of
    90 : cosang:=0;
    180: sinang:=0;
    -90: cosang:=0;
    -180: sinang:=0
    end;
   sourceleftlimit:=-(source.Width div 2);
   sourcerightlimit:=source.Width div 2 ;
   sourcetoplimit:=-(source.Height div 2);
   sourceBotlimit:=source.Height div 2 ;
   sourcescan:=source.scanline[source.height-1];
   destscan:=target.ScanLine[target.height-1];
//   sourcewidth:=source.Width; destwidth:=target.Width;
   dx2:=(target.Width div 2);
   dy2:=(target.height div 2) ;
   dx1:=(source.Width div 2) ;
   dy1:=(source.Height div 2) ;

   for y2:=0 to target.Height-1 do
   for x2:=0 to target.Width-1 do
   begin ix:=x2-dx2; iy:=y2-dy2;
     //we check to see which points in the image1 will map into image2
     x:=trunc(ix*cosang+iy*sinang);
     y:=trunc(iy*cosang-ix*sinang);
     if (x>=sourceleftlimit)and(x<=sourcerightlimit)and
        (y>=sourcetoplimit)and(y<=sourceBotlimit) then
     begin
      if (y+dy1>=source.Height)or(x+dx1>=source.Width) then
      continue;
      if (y2>=target.Height)or(x2>=target.Width)or(x2<0)
      or(y2<0)or(y+dy1<0)or(y+dy1>=source.Height) then
      continue;

      pixelsource:=sourcescan[(y+dy1)*source.Width+x+dx1];

      pixeltarget:=destscan[y2*target.Width+x2];
      if blend=100 then pixeltemp:=pixelsource else
      begin
      TPixelRec(pixeltemp).Blue:=(TPixelRec(pixeltarget).Blue*blend+
                                  TPixelRec(pixelsource).Blue*(100-blend)) div 100;

      TPixelRec(pixeltemp).Green:=(TPixelRec(pixeltarget).Green*blend+
                                  TPixelRec(pixelsource).Green*(100-blend)) div 100;

      TPixelRec(pixeltemp).Red:=(TPixelRec(pixeltarget).Red*blend+
                                  TPixelRec(pixelsource).Red*(100-blend)) div 100;
      end;
      destscan[y2*target.Width+x2]:=pixeltemp
     end
   end
end; //RotateBitmap


procedure ShrinkBitmap(percent : integer; var main,shrunk : Tbitmap);
type trw =array[0..maxint div 6] of DWORD;
     thu =array[0..100000000] of packed record b,g,r,total : DWORD end;

var source, dest : ^trw; s : string; i,j,k,n,x,y,c,mw,mh,th,tw,total1 : DWORD;
    t : tbitmap; TmpPtr : pointer;
    p : ^thu;
begin
   if (percent=100)or(main.Width<10)or(main.Height<10) then
   begin shrunk.Assign(main);
         exit
   end;
   t:=tbitmap.Create; t.PixelFormat:=pf32bit;
   if percent=0 then
   begin t.Width:=10; t.Height:=10
   end;
   t.Width:=main.Width*percent div 100;
   t.Height:=main.Height*percent div 100;
   if (t.Width<10)or(t.Height<10) then
   begin t.Canvas.StretchDraw(rect(0,0,t.width,t.height),main);
         shrunk.Assign(t); t.Free; s:=''; exit
   end;

   source:=main.ScanLine[main.height-1];
   dest:=t.ScanLine[t.height-1];
   i:=t.width*t.height*16;
   setlength(s,i); //allocate some memory
   fillchar(s[1],i,0);
   TmpPtr:=@s[1]; p:=TmpPtr;
   //p:=@s[1];

   mw:=main.Width; mh:=main.Height; th:=t.Height; tw:=t.Width;
  for y:=0 to main.Height-1 do
  begin
   for x:=0 to main.Width-1 do
   begin i:=t.Width * x div mw ;
     j:=t.height * y div mh;  //i,j now map to a pixel in the shrunk bitmap
     k:=(mh-y-1)*mw+x;
     c:=source[k] and $00FFFFFF;

     k:=(th-j-1)*tw+i;
     p[k].r:=p[k].r+(c shr 16);
     p[k].g:=p[k].g+((c and $FFFF)shr 8);
     p[k].b:=p[k].b+(c and $FF);
     inc(p[k].total)
   end;
  end;
  for y:=0 to t.Height-1 do  for x:=0 to t.Width-1 do
  begin k:=(th-y-1)*tw+x;

    c:=p[k].b div p[k].total;  //blue part of pixel
    //we OR them to get the RGB representation of pixel
    c:=c OR ((p[k].g div p[k].total) shl 8);
    c:=c OR ((p[k].r div p[k].total) shl 16);
    dest[k]:=c
  end;
 shrunk.Assign(t); t.Free ; s:=''
end;

procedure BlendBitmap(botbmp,topbmp,rezult : Tbitmap; blend : integer);
type
     Tpixel = packed record blue,green,red, reserved : byte end;  //blue lsb resrved  msb
     wm =array[0..100000000] of Tpixel; //just a dummy storage
var topbitmapscan,botbitmapscan,rezultbitmapscan : ^wm;
    x,y,w,h : integer;
    pixeltop,pixelbot,temp : tpixel;  //top image will be blended on bottom image
begin
   topbitmapscan:=topbmp.ScanLine[topbmp.height-1]; //destbitmap
   botbitmapscan:=botbmp.ScanLine[botbmp.height-1]; //srcbitmap
   rezultbitmapscan:=rezult.scanline[rezult.height-1];
   h:=rezult.Height-1; w:=rezult.Width-1;
   for y:=0 to h do
   for x:=0 to w do
   begin
      pixelbot:=botbitmapscan[(h-y)*botbmp.width+x];
      pixeltop:=topbitmapscan[(h-y)*topbmp.width+x];
      begin
      temp.blue:= (pixeltop.Blue*blend+pixelbot.Blue*(100-blend)) div 100;
      temp.red:=  (pixeltop.red*blend+pixelbot.red*(100-blend)) div 100;
      temp.green:=(pixeltop.green*blend+pixelbot.green*(100-blend)) div 100;
      temp.reserved:=0;
      rezultbitmapscan[(botbmp.height-1-y)*botbmp.width+x]:=temp
      end
   end;
end;

procedure TextOutTransparent(s: string; x,y,blend : integer; destbitmap : Tbitmap );
var t,r,srcbitmap : tbitmap;  i,j,w,h : integer;
begin
     srcbitmap:=tbitmap.Create; srcbitmap.PixelFormat:=pf32bit;
     t:=Tbitmap.Create; t.PixelFormat:=pf32bit;
     r:=Tbitmap.Create; r.PixelFormat:=pf32bit;

      srcbitmap.Canvas.Font:=form3.FontDialog.Font;
      h:=srcbitmap.Canvas.TextHeight('H'); w:=srcbitmap.Canvas.Textwidth(s);
      srcbitmap.Width:=w; srcbitmap.Height:=h;
      t.Width:=w; t.Height:=h;
      r.Width:=w; r.Height:=h;

      i:=w div 2;
      j:=h div 2; //we chose center so when mouse move it will be in the middle of msg
      srcbitmap.Canvas.CopyRect(rect(0,0,w,h),mainbitmap.canvas,rect(x-i,y-j,x+i,y+j));

      t.Assign(srcbitmap);

      srcbitmap.Canvas.Brush.Style:=bsclear;
      srcbitmap.Canvas.TextOut(0,0,s);
      BlendBitmap(t,srcbitmap,r,blend);
      destbitmap.Canvas.Draw(x-i,y-j,r);
      t.Free; r.free; srcbitmap.Free
end;


procedure TForm2.btnbackcolClick(Sender: TObject);
begin if rgbrush.ItemIndex=0 then
     begin
      ColorDialog.Execute;
      shape1.Brush.Color:=ColorDialog.Color; shape1.Pen.Color:=ColorDialog.Color
     end else with form1 do
     begin if OpenPictureDialog.Execute=false then
           begin st1.Caption:='?';
                 exit
           end else
           st1.Caption:=OpenPictureDialog.FileName
     end
end;

procedure TForm2.rgbrushClick(Sender: TObject);
begin btnbackcolClick(nil)
end;

procedure TForm2.btnmakeBMPClick(Sender: TObject);
var w,h : integer;  j : Tjpegimage;  label L1;
begin
 w:=strtointdef(edtw.Text,100); if w<100 then w:=100;
 h:=strtointdef(edth.Text,100); if h<100 then h:=100;
 if mainbitmap<>nil then mainbitmap.Free;
 mainbitmap:=tbitmap.Create; mainbitmap.Width:=w; mainbitmap.Height:=h;
 mainbitmap.PixelFormat:=pf32bit;


       if rgbrush.ItemIndex=0 then  with mainbitmap.canvas do
       begin  brush.Style:=bssolid;
             brush.Color:=shape1.Brush.Color

       end else //use a JPG file as background image
       begin
       if st1.Caption='?' then
       begin showmessage('Background picture not selected yet');
             goto L1
       end;
       if brushbmp=nil then
         begin
         brushbmp:=tbitmap.Create; brushbmp.PixelFormat:=pf32bit
         end;
         j:=TJPEGImage.Create; j.PixelFormat:=jf24Bit;
         j.LoadFromFile(st1.Caption);
         brushbmp.Assign(j);   j.Free;
         mainbitmap.Canvas.Brush.Style:=bssolid;
         mainbitmap.Canvas.Brush.Bitmap:=brushbmp;
       end;
       L1:
       mainbitmap.Canvas.FillRect(rect(0,0,w,h)); form3.rbshrink.Checked:=true;
       form1.image1.Picture.Bitmap.Assign(mainbitmap); ready:=true;
       form1.sb.Panels[1].Text:='W='+inttostr(w)+' H='+inttostr(h);
       form1.ScrollBox.VertScrollBar.Range:=h;
       form1.ScrollBox.HorzScrollBar.Range:=w;
       close
 end;


procedure TForm2.btnmodbmpClick(Sender: TObject);
var h,w : integer;
begin  if mainbitmap=nil then
 begin showmessage('Background picture not selected or ctreated yet ');
       exit
 end else with form1 do
 begin w:=strtointdef(edtw.text,100); h:=strtointdef(edth.text,100);
       mainbitmap.Width:=w; mainbitmap.Height:=h;
 ScrollBox.VertScrollBar.Range:=mainbitmap.Height;
 scrollbox.HorzScrollBar.Range:=mainbitmap.Width;
 sb.Panels[1].Text:='W='+inttostr(mainbitmap.Width)+' H='+inttostr(mainbitmap.Height);
 image1.picture.bitmap.Assign(mainbitmap)
 end

end;

procedure TForm2.edtWKeyPress(Sender: TObject; var Key: Char);
begin if key in ['0'..'9',#8] then else key:=#0

end;

procedure TForm2.edtshrinkmainbmpChange(Sender: TObject);
var i,h,w : integer; t : tbitmap;
begin i:=strtointdef(edtshrinkmainbmp.text,0);
  if i<3 then i:=3 else if i>=100 then  i:=100;
  t:=tbitmap.Create; t.PixelFormat:=pf32bit;
  ShrinkBitmap(i,mainbitmap,t); form1.Image1.Picture.Bitmap.Assign(t);
  w:=t.width; h:=t.height;
  form2.edtW.Text:=inttostr(w); form2.edtH.Text:=inttostr(h);
  if sender=nil then with form1 do //ok button has been pressed
  begin mainbitmap.Assign(t);
        ScrollBox.VertScrollBar.Range:=mainbitmap.Height;
        scrollbox.HorzScrollBar.Range:=mainbitmap.Width
  end;
  t.ReleaseHandle; t.Free
end;

procedure TForm2.edtshrinkmainbmpEnter(Sender: TObject);
begin if ready=false then exit;
  btnokshrink.Enabled:=true; btncancelzoom.Enabled:=true
end;

procedure TForm2.btnokshrinkClick(Sender: TObject);
begin edtshrinkmainbmpChange(nil);
     edtshrinkmainbmp.Text:='100'; edtshrinkmainbmp.Tag:=100;
     btnokshrink.Enabled:=false; btncancelzoom.Enabled:=false;
     form1.sb.Panels[1].Text:='W='+inttostr(mainbitmap.width)+'  H='+inttostr(mainbitmap.height);
     close
end;

procedure TForm2.btncancelzoomClick(Sender: TObject);
var w,h : integer;
begin  form1.Image1.Picture.Bitmap.Assign(mainbitmap);
  h:=mainbitmap.width; w:=mainbitmap.height;
  form2.edtW.Text:=inttostr(w); form2.edtH.Text:=inttostr(h);
  edtshrinkmainbmp.Text:='100'; edtshrinkmainbmp.Tag:=100;
  if sender<>nil then close
end;

end.
